//
//  NSWindow(CGSSecrets).m
//  CGSSecrets
//
//  Created by Dave Jewell on 06/02/2009.
//  Copyright 2009 Cocoa Secrets. All rights reserved.
//

#import "NSWindow(CGSSecrets).h"
#import "CGSPrivate.h"

@implementation NSWindow (CGSSecrets)

- (void) flipWithDuration: (float) duration forwards: (BOOL) forwards
{
	CGSTransitionSpec spec;
	CGSTransitionHandle transitionHandle;
	CGSConnection cid = CGSDefaultConnection;
	
	spec.type = CGSFlip;
	spec.option = 0x80 | (forwards ? 2 : 1);
	spec.wid = [self windowNumber];
	spec.backColor = nil;
	
	transitionHandle = -1;
	CGSNewTransition (cid, &spec, &transitionHandle);
	[self display];
	CGSInvokeTransition (cid, transitionHandle, duration);
	[[NSRunLoop currentRunLoop] runUntilDate: [NSDate dateWithTimeIntervalSinceNow: duration]];
	CGSReleaseTransition (cid, transitionHandle);
}

@end
